diff --git a/src/backend/commands/copy.c b/src/backend/commands/copy.c
index 6d53dc4..2a49255 100644
--- a/src/backend/commands/copy.c
+++ b/src/backend/commands/copy.c
@@ -3858,66 +5644,40 @@ CopyReadLine(CopyState cstate)
 		 */
 		if (cstate->copy_dest == COPY_NEW_FE)
 		{
+			bool bIsFirst = true;
 			do
 			{
-				cstate->raw_buf_index = cstate->raw_buf_len;
-			} while (CopyLoadRawBuf(cstate));
-		}
-	}
-	else
-	{
-		/*
-		 * If we didn't hit EOF, then we must have transferred the EOL marker
-		 * to line_buf along with the data.  Get rid of it.
-		 */
-		switch (cstate->eol_type)
-		{
-			case EOL_NL:
-				Assert(cstate->line_buf.len >= 1);
-				Assert(cstate->line_buf.data[cstate->line_buf.len - 1] == '\n');
-				cstate->line_buf.len--;
-				cstate->line_buf.data[cstate->line_buf.len] = '\0';
-				break;
-			case EOL_CR:
-				Assert(cstate->line_buf.len >= 1);
-				Assert(cstate->line_buf.data[cstate->line_buf.len - 1] == '\r');
-				cstate->line_buf.len--;
-				cstate->line_buf.data[cstate->line_buf.len] = '\0';
-				break;
-			case EOL_CRNL:
-				Assert(cstate->line_buf.len >= 2);
-				Assert(cstate->line_buf.data[cstate->line_buf.len - 2] == '\r');
-				Assert(cstate->line_buf.data[cstate->line_buf.len - 1] == '\n');
-				cstate->line_buf.len -= 2;
-				cstate->line_buf.data[cstate->line_buf.len] = '\0';
-				break;
-			case EOL_UNKNOWN:
-				/* shouldn't get here */
-				Assert(false);
-				break;
-		}
-	}
-
-	/* Done reading the line.  Convert it to server encoding. */
-	if (cstate->need_transcoding)
-	{
-		char	   *cvt;
+				if (!IsParallelCopy())
+					cstate->raw_buf_index = cstate->raw_buf_len;
+				else
+				{
+					if (cstate->raw_buf_index == RAW_BUF_SIZE)
+					{
+						/* Get a new block if it is the first time */
+						if (bIsFirst)
+						{
+							ShmCopyInfo *pcshared_info = cstate->pcdata->pcshared_info;
+							uint32 block_pos = WaitGetFreeCopyBlock(pcshared_info);
+							cstate->raw_buf = pcshared_info->data_blocks[block_pos].data;
+							cstate->raw_buf_index = cstate->raw_buf_len = 0;
+							bIsFirst = false;
+						}
+						else
+						{
+							/*
+							 * From the subsequent time, reset the index and
+							 * re-use the same block.
+							 */
+							cstate->raw_buf_index = cstate->raw_buf_len = 0;
+						}
+					}
+				}
 
-		cvt = pg_any_to_server(cstate->line_buf.data,
-							   cstate->line_buf.len,
-							   cstate->file_encoding);
-		if (cvt != cstate->line_buf.data)
-		{
-			/* transfer converted data back to line_buf */
-			resetStringInfo(&cstate->line_buf);
-			appendBinaryStringInfo(&cstate->line_buf, cvt, strlen(cvt));
-			pfree(cvt);
+			} while (CopyLoadRawBuf(cstate, cstate->raw_buf_len, &cstate->raw_buf_index));
 		}
 	}
 
-	/* Now it's safe to use the buffer in error messages */
-	cstate->line_buf_converted = true;
-
+	CONVERT_TO_SERVER_ENCODING(cstate)
 	return result;
 }
 
@@ -3927,9 +5687,6 @@ CopyReadLine(CopyState cstate)
 static bool
 CopyReadLineText(CopyState cstate)
 {
-	char	   *copy_raw_buf;
-	int			raw_buf_ptr;
-	int			copy_buf_len;
 	bool		need_data = false;
 	bool		hit_eof = false;
 	bool		result = false;
@@ -3942,6 +5699,11 @@ CopyReadLineText(CopyState cstate)
 	char		quotec = '\0';
 	char		escapec = '\0';
 
+	int			chunk_pos = 0;
+	uint32		chunk_first_block = 0;
+	uint32		new_line_size = 0;
+	CopyBufferState copy_buff_state = {0};
+
 	if (cstate->csv_mode)
 	{
 		quotec = cstate->quote[0];
@@ -3974,14 +5736,13 @@ CopyReadLineText(CopyState cstate)
 	 * For a little extra speed within the loop, we copy raw_buf and
 	 * raw_buf_len into local variables.
 	 */
-	copy_raw_buf = cstate->raw_buf;
-	raw_buf_ptr = cstate->raw_buf_index;
-	copy_buf_len = cstate->raw_buf_len;
-
+	BEGIN_READ_LINE(cstate, chunk_first_block)
 	for (;;)
 	{
 		int			prev_raw_ptr;
 		char		c;
+		uint32		prev_chunk_size = copy_buff_state.chunk_size;
+		int			prev_copy_buf_len = copy_buff_state.copy_buf_len;
 
 		/*
 		 * Load more data if needed.  Ideally we would just force four bytes
@@ -3993,35 +5754,70 @@ CopyReadLineText(CopyState cstate)
 		 * cstate->copy_dest != COPY_OLD_FE, but it hardly seems worth it,
 		 * considering the size of the buffer.
 		 */
-		if (raw_buf_ptr >= copy_buf_len || need_data)
+		if (copy_buff_state.raw_buf_ptr >= copy_buff_state.copy_buf_len ||
+			need_data)
 		{
+			uint32 remaining_data;
 			REFILL_LINEBUF;
 
+			/* In parallel mode, read as much data as possible to a new block */
+			if (IsParallelCopy())
+				SET_RAWBUF_FOR_LOAD()
+
+			remaining_data = copy_buff_state.copy_buf_len - copy_buff_state.raw_buf_ptr;
+
 			/*
 			 * Try to read some more data.  This will certainly reset
 			 * raw_buf_index to zero, and raw_buf_ptr must go with it.
 			 */
-			if (!CopyLoadRawBuf(cstate))
+			if (!CopyLoadRawBuf(cstate, copy_buff_state.copy_buf_len,
+								&copy_buff_state.raw_buf_ptr))
 				hit_eof = true;
-			raw_buf_ptr = 0;
-			copy_buf_len = cstate->raw_buf_len;
+
+			remaining_data += cstate->raw_buf_len;
 
 			/*
-			 * If we are completely out of data, break out of the loop,
-			 * reporting EOF.
+			 * If all the data of previous block is not consumed, set raw_buf back to
+			 * previous block.
 			 */
-			if (copy_buf_len <= 0)
+			if (IsParallelCopy() && need_data &&
+				(copy_buff_state.curr_data_blk_ptr != copy_buff_state.data_blk_ptr))
+			{
+				copy_buff_state.copy_buf_len += cstate->raw_buf_len;
+				cstate->raw_buf = copy_buff_state.data_blk_ptr->data;
+			}
+			else
+				copy_buff_state.copy_buf_len = cstate->raw_buf_len;
+
+			need_data = false;
+			if (remaining_data <= 0)
 			{
+				/*
+				 * If we are completely out of data, break out of the loop,
+				 * reporting EOF.
+				 */
 				result = true;
 				break;
 			}
-			need_data = false;
 		}
 
-		/* OK to fetch a character */
-		prev_raw_ptr = raw_buf_ptr;
-		c = copy_raw_buf[raw_buf_ptr++];
+		/*
+		 * Store the current information, we might have to reset if we find that
+		 * enough data is not present while reading. If enough data is not
+		 * present, we will reset using the current information and load more
+		 * data.
+		 */
+		prev_raw_ptr = copy_buff_state.raw_buf_ptr;
+		if (IsParallelCopy())
+		{
+			prev_copy_buf_len = copy_buff_state.copy_buf_len;
+			prev_chunk_size = copy_buff_state.chunk_size;
+			copy_buff_state.block_switched = false;
+		}
 
+		/* OK to fetch a character */
+		c = copy_buff_state.copy_raw_buf[copy_buff_state.raw_buf_ptr];
+		SEEK_COPY_BUFF_POS(cstate, 1, copy_buff_state)
 		if (cstate->csv_mode)
 		{
 			/*
@@ -4079,11 +5875,10 @@ CopyReadLineText(CopyState cstate)
 				IF_NEED_REFILL_AND_NOT_EOF_CONTINUE(0);
 
 				/* get next char */
-				c = copy_raw_buf[raw_buf_ptr];
-
+				c = copy_buff_state.copy_raw_buf[copy_buff_state.raw_buf_ptr];
 				if (c == '\n')
 				{
-					raw_buf_ptr++;	/* eat newline */
+					SEEK_COPY_BUFF_POS(cstate, 1, copy_buff_state)	/* eat newline */
 					cstate->eol_type = EOL_CRNL;	/* in case not set yet */
 				}
 				else
@@ -4153,11 +5948,11 @@ CopyReadLineText(CopyState cstate)
 			 * through and continue processing for file encoding.
 			 * -----
 			 */
-			c2 = copy_raw_buf[raw_buf_ptr];
+			c2 = copy_buff_state.copy_raw_buf[copy_buff_state.raw_buf_ptr];
 
 			if (c2 == '.')
 			{
-				raw_buf_ptr++;	/* consume the '.' */
+				SEEK_COPY_BUFF_POS(cstate, 1, copy_buff_state)	/* consume the '.' */
 
 				/*
 				 * Note: if we loop back for more data here, it does not
@@ -4169,7 +5964,8 @@ CopyReadLineText(CopyState cstate)
 					/* Get the next character */
 					IF_NEED_REFILL_AND_NOT_EOF_CONTINUE(0);
 					/* if hit_eof, c2 will become '\0' */
-					c2 = copy_raw_buf[raw_buf_ptr++];
+					c2 = copy_buff_state.copy_raw_buf[copy_buff_state.raw_buf_ptr];
+					SEEK_COPY_BUFF_POS(cstate, 1, copy_buff_state)
 
 					if (c2 == '\n')
 					{
@@ -4194,7 +5990,8 @@ CopyReadLineText(CopyState cstate)
 				/* Get the next character */
 				IF_NEED_REFILL_AND_NOT_EOF_CONTINUE(0);
 				/* if hit_eof, c2 will become '\0' */
-				c2 = copy_raw_buf[raw_buf_ptr++];
+				c2 = copy_buff_state.copy_raw_buf[copy_buff_state.raw_buf_ptr];
+				SEEK_COPY_BUFF_POS(cstate, 1, copy_buff_state)
 
 				if (c2 != '\r' && c2 != '\n')
 				{
@@ -4220,14 +6017,21 @@ CopyReadLineText(CopyState cstate)
 				 * discard the data and the \. sequence.
 				 */
 				if (prev_raw_ptr > cstate->raw_buf_index)
-					appendBinaryStringInfo(&cstate->line_buf,
+				{
+					if (!IsParallelCopy())
+						appendBinaryStringInfo(&cstate->line_buf,
 										   cstate->raw_buf + cstate->raw_buf_index,
 										   prev_raw_ptr - cstate->raw_buf_index);
-				cstate->raw_buf_index = raw_buf_ptr;
+					else
+						copy_buff_state.chunk_size = prev_chunk_size;
+				}
+
+				cstate->raw_buf_index = copy_buff_state.raw_buf_ptr;
 				result = true;	/* report EOF */
 				break;
 			}
 			else if (!cstate->csv_mode)
+			{
 
 				/*
 				 * If we are here, it means we found a backslash followed by
@@ -4240,7 +6044,8 @@ CopyReadLineText(CopyState cstate)
 				 * character after the backslash just like a normal character,
 				 * so we don't increment in those cases.
 				 */
-				raw_buf_ptr++;
+				SEEK_COPY_BUFF_POS(cstate, 1, copy_buff_state)
+			}
 		}
 
 		/*
@@ -4272,8 +6077,27 @@ not_end_of_copy:
 
 			IF_NEED_REFILL_AND_NOT_EOF_CONTINUE(mblen - 1);
 			IF_NEED_REFILL_AND_EOF_BREAK(mblen - 1);
-			raw_buf_ptr += mblen - 1;
+			SEEK_COPY_BUFF_POS(cstate, mblen - 1, copy_buff_state)
+		}
+
+		/*
+		 * Skip the header line. Update the chunk here, this cannot be done at
+		 * the beginning, as there is a possibility that file contains empty
+		 * lines.
+		 */
+		if (IsParallelCopy() && first_char_in_line && !IsHeaderLine())
+		{
+			ShmCopyInfo	*pcshared_info = cstate->pcdata->pcshared_info;
+			ChunkBoundary *chunkInfo;
+			chunk_pos = UpdateBlockInChunkInfo(cstate,
+											   chunk_first_block,
+											   cstate->raw_buf_index, -1,
+											   CHUNK_LEADER_POPULATING);
+			chunkInfo = &pcshared_info->chunk_boundaries.ring[chunk_pos];
+			elog(DEBUG1, "[Leader] Adding - block:%d, offset:%d, chunk position:%d",
+						 chunk_first_block,	chunkInfo->start_offset, chunk_pos);
 		}
+
 		first_char_in_line = false;
 	}							/* end of outer loop */
 
@@ -4281,6 +6105,11 @@ not_end_of_copy:
 	 * Transfer any still-uncopied data to line_buf.
 	 */
 	REFILL_LINEBUF;
+	CLEAR_EOL_LINE()
+
+	/* Skip the header line */
+	if (IsParallelCopy())
+		END_CHUNK_PARALLEL_COPY()
 
 	return result;
 }
diff --git a/src/backend/optimizer/util/clauses.c b/src/backend/optimizer/util/clauses.c
index 0c6fe01..3faadb8 100644
--- a/src/backend/optimizer/util/clauses.c
+++ b/src/backend/optimizer/util/clauses.c
@@ -865,7 +865,7 @@ is_parallel_safe(PlannerInfo *root, Node *node)
 	 * planning, because those are parallel-restricted and there might be one
 	 * in this expression.  But otherwise we don't need to look.
 	 */
-	if (root->glob->maxParallelHazard == PROPARALLEL_SAFE &&
+	if (root != NULL && root->glob->maxParallelHazard == PROPARALLEL_SAFE &&
 		root->glob->paramExecTypes == NIL)
 		return true;
 	/* Else use max_parallel_hazard's search logic, but stop on RESTRICTED */
diff --git a/src/backend/replication/logical/tablesync.c b/src/backend/replication/logical/tablesync.c
index c27d970..b3787c1 100644
--- a/src/backend/replication/logical/tablesync.c
+++ b/src/backend/replication/logical/tablesync.c
@@ -557,7 +557,7 @@ make_copy_attnamelist(LogicalRepRelMapEntry *rel)
  * Data source callback for the COPY FROM, which reads from the remote
  * connection and passes the data back to our local COPY.
  */
-static int
+int
 copy_read_data(void *outbuf, int minread, int maxread)
 {
 	int			bytesread = 0;
diff --git a/src/include/access/xact.h b/src/include/access/xact.h
index 7ee04ba..6933ade 100644
--- a/src/include/access/xact.h
+++ b/src/include/access/xact.h
@@ -381,6 +381,7 @@ extern FullTransactionId GetTopFullTransactionId(void);
 extern FullTransactionId GetTopFullTransactionIdIfAny(void);
 extern FullTransactionId GetCurrentFullTransactionId(void);
 extern FullTransactionId GetCurrentFullTransactionIdIfAny(void);
+extern void AssignFullTransactionIdForWorker(FullTransactionId fullTransactionId);
 extern void MarkCurrentTransactionIdLoggedIfAny(void);
 extern bool SubTransactionIsActive(SubTransactionId subxid);
 extern CommandId GetCurrentCommandId(bool used);
diff --git a/src/include/commands/copy.h b/src/include/commands/copy.h
index c639833..5dc95ac 100644
--- a/src/include/commands/copy.h
+++ b/src/include/commands/copy.h
@@ -14,6 +14,7 @@
 #ifndef COPY_H
 #define COPY_H
 
+#include "access/parallel.h"
 #include "nodes/execnodes.h"
 #include "nodes/parsenodes.h"
 #include "parser/parse_node.h"
@@ -41,4 +42,7 @@ extern uint64 CopyFrom(CopyState cstate);
 
 extern DestReceiver *CreateCopyDestReceiver(void);
 
+extern void ParallelCopyMain(dsm_segment *seg, shm_toc *toc);
+
+extern int copy_read_data(void *outbuf, int minread, int maxread);
 #endif							/* COPY_H */
diff --git a/src/tools/pgindent/typedefs.list b/src/tools/pgindent/typedefs.list
index 05c5e9c..ad5fbd0 100644
--- a/src/tools/pgindent/typedefs.list
+++ b/src/tools/pgindent/typedefs.list
@@ -337,6 +337,9 @@ CheckpointStatsData
 CheckpointerRequest
 CheckpointerShmemStruct
 Chromosome
+ChunkBoundaries
+ChunkBoundary
+ChunkState
 CkptSortItem
 CkptTsStatus
 ClientAuthentication_hook_type
@@ -419,6 +422,8 @@ ConvProcInfo
 ConversionLocation
 ConvertRowtypeExpr
 CookedConstraint
+CopyBufferState
+CopyDataBlock
 CopyDest
 CopyInsertMethod
 CopyMultiInsertBuffer
@@ -426,6 +431,7 @@ CopyMultiInsertInfo
 CopyState
 CopyStateData
 CopyStmt
+CopyWorkerCommonData
 Cost
 CostSelector
 Counters
@@ -1278,6 +1284,7 @@ LimitStateCond
 List
 ListCell
 ListDictionary
+ListInfo
 ListParsedLex
 ListenAction
 ListenActionKind
@@ -1699,6 +1706,8 @@ ParallelBitmapHeapState
 ParallelBlockTableScanDesc
 ParallelCompletionPtr
 ParallelContext
+ParallelCopyData
+ParallelCopyLineBuf
 ParallelExecutorInfo
 ParallelHashGrowth
 ParallelHashJoinBatch
@@ -2264,6 +2273,7 @@ Sharedsort
 ShellTypeInfo
 ShippableCacheEntry
 ShippableCacheKey
+ShmCopyInfo
 ShmemIndexEnt
 ShutdownForeignScan_function
 ShutdownInformation
-- 
1.8.3.1

